
/*
 *     Zadatak #6
 *  Slijepcevic Dusan
 *  dusans@drenik.net
 *     367/2000
 */

#include <stdio.h>

typedef enum {VTS_NFOUND=-1,VTS_OK,VTS_TOO_LONG} VTS_RESULT;
#define VTS_ERR -1
/* genericka greska */

#define INDENT 4
/* estetika... */

#define MAX_H 200
/*  maks. broj karaktera ne racunajuci
 *  umetnute, a ni <Hn..>/</Hn..> etikete
 */

#undef  upper
#define upper(c) ( (c>='a'&&c<='z')?(c-('a'-'A')):(c) )

int VadiNaslov(char*,int*);
int Analiza(char*,int,char*);
int LogickaStruktura(int);
int NajdubljiNaslov(char*,char*);
int NumerisanNaslov(char*);

const char szInvT[] = "Greska: Nedozvoljena etiketa u redu %.4d !\n";
const char szAttr[] = "Greska: Nedozvoljeni atribut etikete naslova u redu %.4d !\n";
const char szSPC [] = "Upozorenje: Blanko karakter(i) posle \"<\" karaktera u redu %.4d !\n";
int red=1;


/****************************************************************************
 *
 *  int VadiNaslov(char*,int*)   - F-ja koja "chupa":) naslov iz ulaznog stream-a
 *
 *  Parametri:
 *    - buf: pointer na buffer duzine [MAX_H+1] koji ce prihvatiti izdvojeni naslov
 *    - lev: adresa promenljive u kojoj se vraca "dubina" naslova (n od "<Hn...>")
 *
 *  Buf ce po uspesnom "vadjenju" sadrzati naslov sa sledecim osobinama:
 *    - Sve ugnjezdene etikete (<i>...</i> i sl.) ce biti uklonjene
 *    - Ugnjezdeni <Hn...> tagovi nisu dozvoljeni
 *    - Izbacuju se i <Hn></Hn> tagovi - "dubina" se vraca u promenljivoj lev
 *    - <Hn...> etiketa ne sme imati dodatne atribute (align=...)
 *    - Svako pojavljivanje '\n' unutar naslova bice zamenjeno ' ' karakterom
 *    - Maksimalna dozvoljena duzina za tako "cist" naslov je MAX_H karaktera (bez '\0')
 *
 *  Povratne vrednosti:
 *    - VTS_NFOUND:     U tekstu (vise) nema naslova
 *    - VTS_OK:         Naslov je uspesno izdvojen!
 *    - VTS_TOO_LONG:   Duzina "cistog" naslova (bez ikakvih tagova) > MAX_H karaktera
 *
 *  Napomena:
 *    Funkcija detektuje i suvisne (nedozvoljene) '<' '>' karaktere, vodi
 *    racuna o "<!...>" komentarima, o dodatnim atributima <Hn...> etikete
 *    kao i o jos nekim stvarima... (SCRIPT tagovi se ovde ne racunaju:)
 *
 ****************************************************************************/

int VadiNaslov(char *buf,int *lev)
{
  int c;    /* vrlo "zaposlena" promenljiva */
  int i;    /* indeks buf niza */
  int n;    /* "dubina" naslova (n od "<Hn...>") */
  int inT;  /* fleg - da li smo u tagu, tj. izmedju '<' i '>' ? */
  int inC;  /* fleg - da li smo u komentaru "<!...>" ? */
  int inH;  /* fleg - da li smo _izmedju_ "<Hn...>" i "</Hn...>" ? */

  inT=inH=inC=i=n=*buf=buf[MAX_H]=0;
  while ((c=getc(stdin))!=EOF) {
    switch(c) {
    case '<':
      if (inC) continue;
      else if ((c=getc(stdin))!=EOF) {
        inT=1;
        switch(c) {
        case '!': inT=0; inC=1; break;
        case '/':
          if (inH && (c=getc(stdin))=='h'||c=='H') {
            if ((c=getc(stdin))==n) {  /* "</H" */
              if ((c=getc(stdin))!=' ' && c!= '\t'&&
                   c!='\n' && c!='>') {
                fprintf(stderr,szInvT,red);
                return VTS_NFOUND;
              }
              for (;c!=EOF && (c==' '||c=='\t'||
                    c=='\n');c=getc(stdin))
                if (c=='\n') red++;    /* "</Hn ???" */
                if (c==EOF) {
                  fprintf(stderr,szInvT,red);
                  return VTS_NFOUND;
                } else if (c!='>') {
                  fprintf(stderr,szAttr,red);
                  return VTS_NFOUND;
                } else if (i<=MAX_H) { /* "</Hn ... >" */
                  inT=buf[i]=0;
                  *lev = (int) (n-'0');
                  return VTS_OK;
                } else return VTS_TOO_LONG;
            }  /* c!=n "</Hx" */
            else if (c=='\n'||c=='\t'||c==' ')
              fprintf(stderr,szSPC,c=='\n'?++red:red);
          }   /* "</x" */
          break;

        case 'h':
        case 'H':   /* "<H?" */
          if ((c=getc(stdin))>='1' && c<='6') {
            if (inH) {
              fprintf(stderr,"Greska: Ugnjezdene <Hn...>"
                " etikete! Red: %.4d\n",red);
              return VTS_NFOUND;
            }
            n=c;
            if ((c=getc(stdin))!=' '&& c!='\t'&&
                 c!='\n'&& c!='>') {
              fprintf(stderr,szInvT,red);
              return VTS_NFOUND;
            }
            for (;c!=EOF && (c==' '||c=='\t'||
                  c=='\n');c=getc(stdin))
              if (c=='\n') red++;
              if (c==EOF) {
                fprintf(stderr,szInvT,red);
                return VTS_NFOUND;
              } else if (c!='>') {
                fprintf(stderr,szAttr,red);
                return VTS_NFOUND;
              } else inT=0,inH=1; /* "Hn ... >" */
          }   /* "<Hx> */
          else if (c=='\n'||c=='\t'||c==' ')
            fprintf(stderr,szSPC,c=='\n'?++red:red);
          break;

        case '\n': /* "<[SPC]" */
        case '\t':
        case ' ' :
          fprintf(stderr,szSPC,c=='\n'?++red:red);
          break;
        } /* switch #2 */
      }  /* "<?" */
      break;

    case '>':
      if (inC) inC=0;
      else if (inT) inT=0;
      else {
        fprintf(stderr,"Greska: Etiketa nije otvorena! Red: %.4d\n",red);
        return VTS_NFOUND;
      }
      break;

    case '\n':
      ++red;
      c=' ';   /* zameni '\n' sa ' ' */
    default:   /* ovde nema break-a  */
      if (inH && !inT && !inC) {
        if (i<MAX_H) buf[i++]=c;
        else return VTS_TOO_LONG;
      }
      break;
    }
  }

  if (inT||inC||inH)
    fprintf(stderr,"Greska: Etiketa nije zatvorena! Red: %.4d\n",red);

  return VTS_NFOUND;
}


/****************************************************************************
 *
 *  int Analiza(char*,int,char*)   - MATF Analiza()  brrr... :)
 *
 *  Parametri:
 *    - naslov:  Mozda naslov (?!) :)
 *    - d:       Dubina naslova koji se analizira
 *    - nn:      Naslov koji bi trebalo da bude na najvecoj dubini
 *
 *  Povratne vrednosti:
 *    - VTS_OK:    Kockice se slazu - naslov prihvacen!
 *    - VTS_ERR:   Doslo je do neke (manje) katastrofe...
 *
 *  Uslovi korektnosti:
 *    - Dubina naslova (karakter n) mora biti izmedju 2 i 6.
 *    - Dubine moraju odgovarati logickoj strukturi teksta.
 *    - Naslovi koji zvezdicama (npr. ***) razdvajaju delove poglavlja su
 *      naslovi najvece dubine u datom tekstu.
 *    - U numerisanim naslovima sadrzaj etikete [BROJ] mora biti zapisan
 *      alfabetskim znacima: npr. <H3>[Pet]Neki naslov</H3>
 *    - Na izlazu se ispisuje poravnata lista naslova...
 *
 ****************************************************************************/

int Analiza(char *naslov,int d, char *nn)
{
  int ind;
  char *s=naslov;
  static int maxNorm=0; /* maks. dubina "normalnog" naslova */
  static int maxNN=0;   /* maks. dubina spec. "najdubljeg" naslova (nn) */

  if (d==1) {  /* naslov <H1> nije dozvoljen */
    fprintf(stderr,"Greska: Dozvoljena \"dubina\" naslova"
      " je od 2-6! Red %.4d \n",red);
    return VTS_ERR;
  }

  if (LogickaStruktura(d) == VTS_ERR)
    fprintf(stderr,"Upozorenje: Dubina naslova ne odgovara"
      " logickoj strukturi teksta. Red: %.4d\n",red);

  for (;*s==' '||*s=='\t'||*s=='\n';s++);
  if (!*s) naslov = "[-=Prazan naslov=-]";

  if (!NajdubljiNaslov(naslov,nn)) {
    if (d>maxNorm) maxNorm=d;
    if (maxNN && d>=maxNN)
      fprintf(stderr,"Upozorenje: Dubina naslova u redu %.4d je"
      " >= od dubine [%s] naslova!\n",red,nn);
  } else {
    if (!maxNN) {
      maxNN=d;
      if (maxNorm>=d)
        fprintf(stderr,"Upozorenje: Naslov [%s] nije"
        " na najvecoj dubini!\n",nn);
    } else if (d!=maxNN)
      fprintf(stderr,"Upozorenje: Dubine [%s] naslova se"
      " ne poklapaju! Red: %.4d\n",nn,red);
  }

  if (NumerisanNaslov(naslov) == VTS_ERR)
    fprintf(stderr,"Upozorenje: Numerisani naslov sadrzi cifru/e"
    " unutar [BROJ] zagrade! Red: %.4d\n",red);

  ind=(d-1)*INDENT;
  printf("Red = %.4d", red);
  while (ind--) putc(' ', stdout);
  printf("%d  %s\n", d, naslov);
  return VTS_OK;
}


/****************************************************************************
 *
 *  int LogickaStruktura(int)   - Testiranje logicke strukture teksta
 *
 *  Parametri:
 *    - d:  Dubina (trenutnog) naslova koji se analizira
 *
 *  Povratne vrednosti:
 *    - VTS_OK:    Sve je u redu, analiza se nastavlja
 *    - VTS_ERR:   Nesto se tu zbiva sto se nikako ne slaze...
 *
 *  Napomena:
 *    "Dubine" moraju odgovarati logickoj strukturi teksta.
 *    (iza naslova dubine 2, sledi ili naslov dubine 2 ili dubine 3;
 *    iza naslova dubine 3, sledi naslov dubine 2, dubine 3 ili dubine 4; itd.)
 *
 ****************************************************************************/

int LogickaStruktura(int d)
{
  static int p=0;  /* dubina prethodnog naslova */
  int res;

  if (!p) p=d;  /* ako se ne testira _prvi_ naslov... */
  if ((res=d-p)<-1 || res>1) return VTS_ERR;
  else { p=d; return VTS_OK; }
}


/****************************************************************************
 *
 *  int NajdubljiNaslov(char*,char*)  - "advanced" strcmp... :)
 *
 *  Parametri:
 *    - s(rc):  Naslov koji se poredi
 *    - pat:    Uzorak koji se trazi
 *
 *  Povratne vrednosti:
 *    - 1:   Stringovi se poklapaju
 *    - 0:   Ipak nije u pitanju najdublji naslov (onaj zadat iz cmdline)
 *
 *  Napomena:
 *    Pat string ne bi trebalo da sadrzi blanko (tj.'\t','\n',' ') znakove
 *    na samom pocetku (ili tik pre zavrsnog '\0').
 *    Sledeci primer vraca true:
 *
 *        *s="  \t C=64 rulezzz!\t  \t";
 *        *pat="C=64 rulezzz!";
 *
 *    dok ovaj drugi bas i ne:
 *
 *        *s="  \t C=64 rulezzz!\t  \t";
 *        *pat=" C=64 rulezzz!";
 *              |
 *          space here
 *
 *    strcmp koji bi podrzavao WILDCARDS bi vec bio malo komplikovaniji...
 *
 ****************************************************************************/

int NajdubljiNaslov(char *s,char *pat)
{
  for (; *s==' '||*s=='\t'||*s=='\n';s++);
  for (;upper(*s)==upper(*pat);++s,++pat)
    if (!*s) return 1;

  if (!*pat&&(*s==' '||*s=='\t'||*s=='\n')) {
    for (++s;*s==' '||*s=='\t'||*s=='\n';s++);
    if (!*s) return 1;
  }
  return 0;
}


/****************************************************************************
 *
 *  int NumerisanNaslov(char*)  - Testira "[SPC][BROJ]Naslov"
 *
 *  Parametri:
 *    - s:  Naslov koji se testira
 *
 *  Povratne vrednosti:
 *    - VTS_OK:   Naslov je ispravan
 *    - VTS_ERR:  Greska: unutar "[BROJ]" se pojavljuju cifre (znaci '0'-'9')
 *
 *  Napomena:
 *    Ovde se testira SAMO prva "[]" zagrada i to ona koja sledi NEPOSREDNO
 *    iza pocetnog "<Hn...>" taga (doduse, beline se preskacu). Sve ostale "[]"
 *    zagrade se ignorisu. Ukoliko zagrada nije zatvorena (ne postoji ']') deo
 *    naslova iza '[' se onda ne posmatra kao "[broj" vec se '[' posmatra kao
 *    "usamljeni" karakter! U tom slucaju se vraca VTS_OK cak i ako se posle
 *    '[' karaktera pojavljuje cifra (znak '0'-'9')!
 *
 ****************************************************************************/

int NumerisanNaslov(char *s)
{
  for (;*s==' '||*s=='\t'||*s=='\n';s++);
  if (*s++=='[') {
    for (;*s && (*s<'0'||*s>'9') && *s!=']';s++);
    if (*s && *s!=']')
      while (*++s) if (*s==']')
        return VTS_ERR;
  }
  return VTS_OK;
}

/****************************************************************************
 *
 *  int main(int,char*)
 *
 *  Napomena (D.Vitas):
 *    Kao argument komandne linije moguce je zadati string koji bi onda
 *    predstavljao prototip "NAJDUBLJEG" naslova (pogledati funkciju
 *    NajdubljiNaslov(...)). Ostali argumenti se ignorisu.
 *    Podrazumevana vrednost za najdublji naslov je "***".
 *
 *  Primer poziva:
 *    proggy.exe <Koska.html >@Out.DuX -*-
 *
 ****************************************************************************/

int main(int argc, char **argv)
{
  VTS_RESULT res;
  char naslov[MAX_H+1];
  int d,eXists = 0;
  char *nn=(argc==1)?"***":*++argv;

  while ((res = VadiNaslov(naslov,&d)) != VTS_NFOUND) {
    eXists = 1;
    if (res == VTS_TOO_LONG) {
      fprintf(stderr, "\nGreska: Predugacak naslov "
        "(maks. 200 karaktera):\n%s\n", naslov);
      break;
    } else if ( Analiza(naslov,d,nn) == VTS_ERR) break;
  }

  if (!eXists) printf("U tekstu nema naslova.\n");
  return 0;
}
